function varargout = xledksettings(varargin)
% XLEDKSETTINGS M-file for xledksettings.fig
%      XLEDKSETTINGS, by itself, creates a new XLEDKSETTINGS or raises the existing
%      singleton*.
%
%      H = XLEDKSETTINGS returns the handle to a new XLEDKSETTINGS or the handle to
%      the existing singleton*.
%
%      XLEDKSETTINGS('Property','Value',...) creates a new XLEDKSETTINGS using the
%      given property value pairs. Unrecognized properties are passed via
%      varargin to xledksettings_OpeningFcn.  This calling syntax produces a
%      warning when there is an existing singleton*.
%
%      XLEDKSETTINGS('CALLBACK') and XLEDKSETTINGS('CALLBACK',hObject,...) call the
%      local function named CALLBACK in XLEDKSETTINGS.M with the given input
%      arguments.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Last Modified by GUIDE v2.5 24-Feb-2004 16:32:55

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @xledksettings_OpeningFcn, ...
                   'gui_OutputFcn',  @xledksettings_OutputFcn, ...
                   'gui_LayoutFcn',  [], ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before xledksettings is made visible.
function xledksettings_OpeningFcn(hObject, eventdata, handles, varargin)
handles.block=varargin{1}.block;
handles.exportdirpath='';
if (isfield(varargin{1},'xledksettingsdata'))
    edkdata=varargin{1}.xledksettingsdata;
    set(handles.export,'Value',edkdata.export);
    set(handles.exportdir,'String',edkdata.exportdir);
    handles.exportdirpath=edkdata.exportdirpath;
    toggle_control_state(handles,edkdata.export);
end
% Update handles structure
guidata(hObject, handles);
% -- draw icons
xlSetIcon(handles.browse,2);
% UIWAIT makes xledksettings wait for user response (see UIRESUME)
uiwait(hObject);

% --- Outputs from this function are returned to the command line.
function varargout = xledksettings_OutputFcn(hObject, eventdata, handles)
delete(handles.figure1);
varargout{1}=0;

% --- Executes on key press over figure1 with no controls selected.
function figure1_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
 uiresume(handles.figure1);

% --- Executes on button press in ok.
function ok_Callback(hObject, eventdata, handles)
edkdata.export= get(handles.export,'Value');
edkdata.exportdir=get(handles.exportdir,'String');
edkdata.exportdirpath=handles.exportdirpath;
% Set compilation path
xlsetparam(handles.block,'compilation','Export as peripheral to EDK');
xlsetparam(handles.block,'xledksettingsdata',edkdata);
xlsetparamws(handles.block,'work','xledksettingsdata',edkdata);
close(handles.figure1);


% --- Executes on button press in Cancel.
function Cancel_Callback(hObject, eventdata, handles)
close(handles.figure1);

function toggle_control_state(handles,enable)
if (enable)
    set(handles.browse,'Enable','on');
    set(handles.exportdir,'Enable','on');
    set(handles.exportlocationtext,'Enable','on');
else
    set(handles.browse,'Enable','off');
    set(handles.exportdir,'Enable','off');
    set(handles.exportlocationtext,'Enable','off');
end
    

% --- Executes on button press in export.
function export_Callback(hObject, eventdata, handles)
togglestate = get(hObject,'Value');
toggle_control_state(handles,togglestate);

% --- Executes during object creation, after setting all properties.
function exportdir_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


function exportdir_Callback(hObject, eventdata, handles)


% --- Executes on button press in browse.
function browse_Callback(hObject, eventdata, handles)
[filename, pathname] = uigetfile('*.xmp', 'Pick the Xilinx Platform Studio project to import into...');
if ~(isequal(filename,0) | isequal(pathname,0))
    set(handles.exportdir,'String',[pathname filename]);
    handles.exportdirpath=pathname;
end
guidata(hObject, handles);

